osl::move_probability::Feature Class Referenceabstract

`#include <feature.h>`

Inheritance diagram for osl::move_probability::Feature:

## Public Member Functions

| Feature (std::string n, size_t d)
virtual | ~Feature ()
std::string | name () const
virtual double | match (const StateInfo &, const MoveInfo &, int offset, const double *) const =0
size_t | dimension () const

## Static Public Member Functions

static int | classifyEffect9 (const NumEffectState &state, Player player, Square to)

## Private Attributes

std::string | my_name
int | dim

## Detailed Description

Definition at line 16 of file move_probability/feature.h.

## Constructor & Destructor Documentation

## Feature()

osl::move_probability::Feature::Feature | ( | std::string | n,
|  | size_t | d )

inline

Definition at line 21 of file move_probability/feature.h.

References dim, and my_name.

Referenced by osl::move_probability::AddEffectLong::AddEffectLong(), osl::move_probability::AttackFromOpposingSliders::AttackFromOpposingSliders(), osl::move_probability::AttackKing8Long::AttackKing8Long(), osl::move_probability::AttackToOpposingSliders::AttackToOpposingSliders(), osl::move_probability::BishopAttack::BishopAttack(), osl::move_probability::BlockLong::BlockLong(), osl::move_probability::BlockLongFrom::BlockLongFrom(), osl::move_probability::BookMove::BookMove(), osl::move_probability::BreakThreatmate::BreakThreatmate(), osl::move_probability::CapturePtype::CapturePtype(), osl::move_probability::CheckFeature::CheckFeature(), osl::move_probability::CheckmateIfCapture::CheckmateIfCapture(), osl::move_probability::ContinueCapture::ContinueCapture(), osl::move_probability::CoverFork::CoverFork(), osl::move_probability::CoverPawn::CoverPawn(), osl::move_probability::DropAfterOpposingPawn::DropAfterOpposingPawn(), osl::move_probability::DropCaptured::DropCaptured(), osl::move_probability::EscapeThreatened::EscapeThreatened(), osl::move_probability::FromEffect::FromEffect(), osl::move_probability::FromEffectLong::FromEffectLong(), osl::move_probability::King5x5Ptype::King5x5Ptype(), osl::move_probability::KingBlockade::KingBlockade(), osl::move_probability::KingRelativeX::KingRelativeX(), osl::move_probability::KingRelativeY::KingRelativeY(), osl::move_probability::LanceAttack::LanceAttack(), osl::move_probability::LongRecapture::LongRecapture(), osl::move_probability::LureDefender::LureDefender(), osl::move_probability::MoveFromOpposingSliders::MoveFromOpposingSliders(), osl::move_probability::OpposingPawn::OpposingPawn(), osl::move_probability::PatternCommon::PatternCommon(), osl::move_probability::PawnAttack::PawnAttack(), osl::move_probability::PromotionBySacrifice::PromotionBySacrifice(), osl::move_probability::RookAttack::RookAttack(), osl::move_probability::SacrificeAttack::SacrificeAttack(), osl::move_probability::SeeFeature::SeeFeature(), osl::move_probability::SendOff::SendOff(), osl::move_probability::SquareX::SquareX(), osl::move_probability::SquareY::SquareY(), osl::move_probability::TakeBackFeature::TakeBackFeature(), osl::move_probability::ThreatmateByCapture::ThreatmateByCapture(), osl::move_probability::ToEffect::ToEffect(), and osl::move_probability::ToEffectLong::ToEffectLong().

## ~Feature()

osl::move_probability::Feature::~Feature | ( |  | ) |

virtual

Definition at line 7 of file feature_.cc.

## Member Function Documentation

## classifyEffect9()

int osl::move_probability::Feature::classifyEffect9 | ( | const NumEffectState & | state,
|  | Player | player,
|  | Square | to )

inline static

Definition at line 30 of file move_probability/feature.h.

References osl::alt(), osl::NumEffectState::countEffect(), and osl::AdditionalEffect::hasEffect().

Referenced by osl::move_probability::PawnAttack::matchPtype(), and osl::move_probability::PatternCommon::updateCacheOne().

## dimension()

size_t osl::move_probability::Feature::dimension | ( |  | ) | const

inline

Definition at line 28 of file move_probability/feature.h.

References dim.

Referenced by osl::move_probability::DropCaptured::match(), osl::move_probability::FromEffect::match(), osl::move_probability::FromEffectLong::match(), osl::move_probability::SquareX::match(), osl::move_probability::SquareY::match(), osl::move_probability::ToEffect::match(), osl::move_probability::ToEffectLong::match(), and osl::move_probability::FeatureSet::showSummary().

## match()

virtual double osl::move_probability::Feature::match | ( | const StateInfo & | ,
|  | const MoveInfo & | ,
|  | int | offset,
|  | const double * | ) const

pure virtual

Implemented in osl::move_probability::AddEffectLong, osl::move_probability::AttackFromOpposingSliders, osl::move_probability::AttackKing8Long, osl::move_probability::AttackToOpposingSliders, osl::move_probability::BishopAttack, osl::move_probability::BlockLong, osl::move_probability::BlockLongFrom, osl::move_probability::BookMove, osl::move_probability::BreakThreatmate, osl::move_probability::CapturePtype, osl::move_probability::CheckFeature, osl::move_probability::CheckmateIfCapture, osl::move_probability::ContinueCapture, osl::move_probability::CoverFork, osl::move_probability::CoverPawn, osl::move_probability::DropAfterOpposingPawn, osl::move_probability::DropCaptured, osl::move_probability::EscapeThreatened, osl::move_probability::FromEffect, osl::move_probability::FromEffectLong, osl::move_probability::King5x5Ptype, osl::move_probability::KingBlockade, osl::move_probability::KingRelativeX, osl::move_probability::KingRelativeY, osl::move_probability::LanceAttack, osl::move_probability::LongRecapture, osl::move_probability::LureDefender, osl::move_probability::MoveFromOpposingSliders, osl::move_probability::OpposingPawn, osl::move_probability::PatternBase< TestPromotable >, osl::move_probability::PatternBase< false >, osl::move_probability::PatternBase< true >, osl::move_probability::PawnAttack, osl::move_probability::PromotionBySacrifice, osl::move_probability::RookAttack, osl::move_probability::SacrificeAttack, osl::move_probability::SeeFeature, osl::move_probability::SendOff, osl::move_probability::SquareX, osl::move_probability::SquareY, osl::move_probability::TakeBackFeature, osl::move_probability::ThreatmateByCapture, osl::move_probability::ToEffect, and osl::move_probability::ToEffectLong.

## name()

std::string osl::move_probability::Feature::name | ( |  | ) | const

inline

Definition at line 26 of file move_probability/feature.h.

References my_name.

Referenced by osl::move_probability::PatternCommon::PatternCommon(), and osl::move_probability::FeatureSet::showSummary().

## Member Data Documentation

## dim

int osl::move_probability::Feature::dim

private

Definition at line 19 of file move_probability/feature.h.

Referenced by dimension(), Feature(), and osl::move_probability::PatternCommon::PatternCommon().

## my_name

std::string osl::move_probability::Feature::my_name

private

Definition at line 18 of file move_probability/feature.h.

Referenced by Feature(), and name().

The documentation for this class was generated from the following files:

- move_probability/feature.h
- feature_.cc